﻿using System;
using System.IO;

namespace TestProject
{
    /// <summary>
    /// GIF 파트 가비지 데이터
    /// </summary>
    public class GIFPartGarbageData : GIFPart.GIFPartData, GIFPart.IGIFPartContent
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 컨텐트 바이트 배열 - ContentByteArray

        /// <summary>
        /// 컨텐트 바이트 배열
        /// </summary>
        public byte[] ContentByteArray
        {
            get
            {
                return this.dataByteArray;
            }
            set
            {
                this.dataByteArray = value ?? new byte[0];
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - GIFPartGarbageData(dataByteArray)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="dataByteArray">데이터 바이트 배열</param>
        public GIFPartGarbageData(byte[] dataByteArray)
        {
            this.dataByteArray = dataByteArray;
        }

        #endregion
        #region 생성자 -  GIFPartGarbageData(dataByteArray, index)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="dataByteArray">데이터 바이트 배열</param>
        /// <param name="index">인덱스</param>
        public GIFPartGarbageData(ref byte[] dataByteArray, ref int index)
        {
            using(MemoryStream memoryStream = new MemoryStream())
            {
                memoryStream.Write(dataByteArray, index, dataByteArray.Length - index);

                base.dataByteArray = memoryStream.ToArray();
            }

            index = dataByteArray.Length;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 복사 생성하기 - CreateCopy()

        /// <summary>
        /// 복사 생성하기
        /// </summary>
        /// <returns>GIF 파트</returns>
        public override GIFPart CreateCopy()
        {
            byte[] bufferByteArray = new byte[dataByteArray.Length];

            Array.Copy(dataByteArray, bufferByteArray, dataByteArray.Length);

            return new GIFPartGarbageData(bufferByteArray);
        }

        #endregion
    }
}