﻿using System;

namespace TestProject
{
    /// <summary>
    /// GIF 파트 종결자
    /// </summary>
    public class GIFPartTerminator : GIFPart.GIFPartData
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - GIFPartTerminator()

        /// <summary>
        /// 생성자
        /// </summary>
        public GIFPartTerminator()
        {
            this.dataByteArray = new byte[] { 0x3B };
        }

        #endregion
        #region 생성자 - GIFPartTerminator(dataByteArray, index)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="dataByteArray">데이터 바이트 배열</param>
        /// <param name="index">인덱스</param>
        public GIFPartTerminator(ref byte[] dataByteArray, ref int index)
        {
            if(dataByteArray[index] != 0x3B)
            {
                throw new FormatException("The terminating byte is not 0x3B!");
            }

            base.dataByteArray = new byte[] { 0x3B };

            index++;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 복사 생성하기 - CreateCopy()

        /// <summary>
        /// 복사 생성하기
        /// </summary>
        /// <returns>GIF 파트</returns>
        public override GIFPart CreateCopy()
        {
            return new GIFPartTerminator();
        }

        #endregion
    }
}