﻿using System;
using System.Text;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// GIF 16진수 컨트롤
    /// </summary>
    public partial class GIFHexadecimalControl : UserControl
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Field
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region Field

        /// <summary>
        /// 데이터 바이트 배열
        /// </summary>
        private byte[] dataByteArray = null;

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 값 - Value

        /// <summary>
        /// 값
        /// </summary>
        public byte[] Value
        {
            get
            {
                return this.dataByteArray;
            }
            set
            {
                this.dataByteArray = value;

                SetValue(value ?? new byte[0]);
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - GIFHexadecimalControl()

        /// <summary>
        /// 생성자
        /// </summary>
        public GIFHexadecimalControl()
        {
            InitializeComponent();
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 값 설정하기 - SetValue(dataByteArray)

        /// <summary>
        /// 값 설정하기
        /// </summary>
        /// <param name="dataByteArray">데이터 바이트 배열</param>
        private void SetValue(byte[] dataByteArray)
        {
            StringBuilder stringBuilder1 = new StringBuilder();
            StringBuilder stringBuilder2 = new StringBuilder();

            int position = 0;

            bool even = true;

            foreach(byte value in dataByteArray)
            {
                if(position % 16 == 0)
                {
                    if(stringBuilder2.Length != 0)
                    {
                        stringBuilder1.Append("  ");

                        stringBuilder1.Append(stringBuilder2.ToString());

                        stringBuilder2 = new StringBuilder();
                    }

                    if(stringBuilder1.Length != 0)
                    {
                        stringBuilder1.Append(Environment.NewLine);
                    }

                    stringBuilder1.AppendFormat("{0:X8}", position);

                    stringBuilder1.Append(" ");
                }

                if(even)
                {
                    stringBuilder1.Append(" ");
                }

                stringBuilder1.AppendFormat("{0:X2}", value);

                stringBuilder2.Append((value > 0x1F && value < 0x7F) ? (char)value : '.');

                position++;

                even = !even;
            }
            while(position % 16 != 0)
            {
                if(even)
                {
                    stringBuilder1.Append(" ");
                }

                stringBuilder1.Append("  ");

                position++;

                even = !even;
            }

            if(stringBuilder2.Length != 0)
            {
                stringBuilder1.Append("  ");

                stringBuilder1.Append(stringBuilder2.ToString());
            }

            textLabel.Text = stringBuilder1.ToString();
        }

        #endregion
    }
}