﻿using System;
using System.Windows.Forms;

namespace TestProject
{
    /// <summary>
    /// 숫자 선택 폼
    /// </summary>
    public partial class SelectNumberForm : Form
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 값 - Value

        /// <summary>
        /// 값
        /// </summary>
        public decimal Value
        {
            get
            {
                return this.valueNumericUpDown.Value;
            }
            set
            {
                this.valueNumericUpDown.Value = value;
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region 생성자 - SelectNumberForm(title, name, maximumValue, initialValue)

        /// <summary>
        /// 생성자
        /// </summary>
        /// <param name="title">제목</param>
        /// <param name="name">명칭</param>
        /// <param name="maximumValue">최대 값</param>
        /// <param name="initialValue">초기 값</param>
        public SelectNumberForm(string title, string name, decimal maximumValue, decimal initialValue)
        {
            InitializeComponent();

            Text = title;

            this.nameLabel.Text = name + ":";

            this.valueNumericUpDown.Maximum = maximumValue;
            this.valueNumericUpDown.Value   = initialValue;

            this.okButton.Click     += okButton_Click;
            this.cancelButton.Click += cancelButton_Click;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region 표시시 처리하기 - OnShown(e)

        /// <summary>
        /// 표시시 처리하기
        /// </summary>
        /// <param name="e">이벤트 인자</param>
        protected override void OnShown(EventArgs e)
        {
            base.OnShown(e);

            CenterToParent();
        }

        #endregion

        ////////////////////////////////////////////////////////////////////////////////////////// Private

        #region 확인 버튼 클릭시 처리하기 - okButton_Click(sender, e)

        /// <summary>
        /// 확인 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void okButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.OK;
        }

        #endregion
        #region 취소 버튼 클릭시 처리하기 - cancelButton_Click(sender, e)

        /// <summary>
        /// 취소 버튼 클릭시 처리하기
        /// </summary>
        /// <param name="sender">이벤트 발생자</param>
        /// <param name="e">이벤트 인자</param>
        private void cancelButton_Click(object sender, EventArgs e)
        {
            DialogResult = DialogResult.Cancel;
        }

        #endregion
    }
}